// GetFontResourceInfoW-test.cpp by katahiromz
// This file is public domain software (PDS).
#include <windows.h>
#include <stdio.h>

// GetFontResourceInfoW
typedef BOOL (WINAPI *GETFONTRESOURCEINFOW)(LPCWSTR, LPDWORD, LPVOID, DWORD);

#define MAX_COUNT   10

static const LPCWSTR Files[] =
{
    L"C:\\ReactOS\\Fonts\\tahoma.ttf",
    L"C:\\ReactOS\\Fonts\\tahomabd.ttf",
    L"C:\\ReactOS\\Fonts\\DejaVuSansMono.ttf",
    L"C:\\ReactOS\\Fonts\\DroidSansFallback.ttf"
};

int main(void)
{
    WCHAR szW[1024];
    LOGFONTW alf[MAX_COUNT];
    WCHAR szFontTitle[1024];

    FILE *fp = fopen("GetFontResourceInfoW.txt", "wb");
    if (fp == NULL)
    {
        printf("Cannot open file\n");
        return -1;
    }
    fwrite("\xFF\xFE", 2, 1, fp);

    HINSTANCE hGdi32 = LoadLibraryA("gdi32.dll");
    GETFONTRESOURCEINFOW GetFontResourceInfoW =
        (GETFONTRESOURCEINFOW)GetProcAddress(hGdi32, "GetFontResourceInfoW");

    for (size_t i = 0; i < sizeof(Files) / sizeof(Files[0]); ++i)
    {
        wsprintfW(szW, L"###\r\nFile: %s\r\n", Files[i]);
        fwrite(szW, lstrlenW(szW) * sizeof(WCHAR), 1, fp);

        DWORD Size = sizeof(alf);
        ZeroMemory(&alf, sizeof(alf));
        if (GetFontResourceInfoW(Files[i], &Size, &alf, 2))
        {
            for (INT i = 0; i < MAX_COUNT; ++i)
            {
                if (alf[i].lfFaceName[0] == 0)
                    break;

                wsprintfW(szW, L"#%d: %s\r\n", i, alf[i].lfFaceName);
                fwrite(szW, lstrlenW(szW) * sizeof(WCHAR), 1, fp);
            }
        }
    }

    for (size_t i = 0; i < sizeof(Files) / sizeof(Files[0]); ++i)
    {
        wsprintfW(szW, L"###\r\nFile: %s\r\n", Files[i]);
        fwrite(szW, lstrlenW(szW) * sizeof(WCHAR), 1, fp);

        DWORD Size = sizeof(szFontTitle);
        ZeroMemory(szFontTitle, sizeof(szFontTitle));
        if (GetFontResourceInfoW(Files[i], &Size, szFontTitle, 1))
        {
            wsprintfW(szW, L"FontTitle: %s\r\n", szFontTitle);
            fwrite(szW, lstrlenW(szW) * sizeof(WCHAR), 1, fp);
        }
    }

    FreeLibrary(hGdi32);
    fclose(fp);
    return 0;
}
